;;; fast-check.lisp - Muse creating test case annotations with
;;; (1) fast-check test specifications and (2) failing inputs to
;;; functions generated by the fast-check library.
(defpackage :argot-server/muses/fast-check
  (:use :gt/full
        :cl-json
        :argot/argot
        :argot-server/annotation-host
        :argot-server/readtable
        :argot-server/muses/base
        :argot-server/muses/muse
        :argot-server/muses/work-queue
        :software-evolution-library
        :lsp-server
        :lsp-server/protocol
        :cmd)
  (:shadowing-import-from :iterate :with)
  (:import-from :lsp-server.lem-base :buffer :buffer-filename)
  (:import-from :lsp-server/utilities/lsp-utilities :buffer-to-string)
  (:export :fast-check
           :|FastCheckTest|
           :|arbitraries|))
(in-package :argot-server/muses/fast-check)
(in-readtable argot-readtable)


;;; Fast-check muse data structures
(define-constant +muse-name+ "Fast Check"
  :test #'equalp
  :documentation "Name of the fast-check muse.")

(define-constant +typescript-compiler+ "tsc"
  :test #'equalp
  :documentation "Name of the TypeScript compiler.")

(define-constant +javascript-interpreter+ "node"
  :test #'equalp
  :documentation "Name of the JavaScript interpreter.")

(defun get-system-base ()
  (ensure-directory-pathname
   (asdf:system-relative-pathname :argot-server "")))

(defclass fast-check (work-queue-muse) ()
  (:default-initargs
   :name +muse-name+
   :lang '(or javascript typescript))
  (:documentation "fast-check muse which creates test case annotations
from examples generated by running the fast-check library over source
code in a background process."))

(defmethod muse-available? and ((muse fast-check))
  "Return TRUE if the requisite shell commands for the fast-check
muse are installed."
  (and (which +typescript-compiler+)
       (which +javascript-interpreter+)))

(define-interface FastCheckTest (TestCase)
  (|arbitraries| :type list)
  ;; Interface defining a fast-check test.  The test target is the
  ;; function to test, arguments are the parameter names, and arbitraries
  ;; is a list of fast-check arbitraries responsible for the random,
  ;; but deterministic, generation of values to use as function arguments
  ;; in the test.  Please see the fast-check docs for more information on
  ;; arbitraries.
  )

(defgeneric arbitraries (fast-check-test)
  (:documentation "Return the arbitraries slot of FAST-CHECK-TEST.")
  (:method ((fast-check-test FastCheckTest))
    (slot-value fast-check-test '|arbitraries|)))


;;; Fast-check muse entry point
(defmethod process-uri ((muse fast-check) (uri string)
                        &aux (software (uri-buffer-software uri)))
  "Annotate the given URI with fast-check tests and concrete examples
of failing function inputs generated by running the fast-check library."
  (let* ((functions (functions-to-annotate software))
         (fast-check-tests
          (create-fast-check-tests software functions uri))
         (example-cases
          (create-example-cases software fast-check-tests)))
    (nest (did-annotate *server*)
          (create-annotations uri example-cases))))


;;; Annotation creation
(defgeneric create-annotations (uri example-cases)
  (:documentation "Create argot annotations for URI from the
EXAMPLE-CASES contributions built using the fast-check library.")
  (:method ((uri string) (example-cases list))
    (iter (for example-case in example-cases)
          (collect
            (make 'Annotation
                  :textDocument (make 'TextDocumentIdentifier
                                      :uri uri)
                  :contributions (list (create-contribution example-case)))))))

(defgeneric create-contribution (test)
  (:documentation "Create an argot Contribution from the given TEST case.")
  (:method ((test TestCase))
    (make 'Contribution
          :source +muse-name+
          :key (format nil "~a: ~a"
                       (string (class-name (class-of test)))
                       (test-target test))
          :kind ArgotKind.Tests
          :data test)))

(defgeneric functions-to-annotate (software)
  (:documentation "Return the functions to attempt to annotate with fast-check
tests and example failure cases in SOFTWARE.")
  (:method ((software ecma))
    (labels ((nested-function-p (func)
               "Return T if FUNC is nested in another function."
               (find (of-type 'function-ast)
                     (get-parent-asts (genome software) func))))
      (nest (remove-if #'nested-function-p)
            (remove-if-not (of-type 'function-ast))
            (convert 'list)
            (genome software)))))

(defgeneric create-fast-check-tests (software functions &optional uri)
  (:documentation "Create fast-check-test objects from the FUNCTIONS
in SOFTWARE created from URI.")
  (:method ((software ecma) (functions list) &optional uri)
    (nest (remove-if #'null)
          (mapcar (lambda (func)
                    (create-fast-check-test software func uri))
                  functions))))

(defgeneric create-fast-check-test (software func &optional uri)
  (:documentation "Create a fast-check-test object from the FUNCTION
in SOFTWARE created from URI.")
  (:method ((software ecma) (func function-ast) &optional uri)
    (and-let* ((target (fast-check-target (genome software) func))
               (param-names (fast-check-parameter-names func))
               (param-types (fast-check-parameter-types software func uri))
               (arbitraries (mapcar #'arbitrary param-types))
               ((function-body func))
               ((notany #'null arbitraries)))
      (make 'FastCheckTest
            :path (list "")
            :testCaseKind TestCaseKind.UnitTest
            :target target
            :arguments param-names
            :arbitraries arbitraries))))

(defgeneric fast-check-target (root func)
  (:documentation "Return the name of or variable assigned to the
function FUNC, if possible.")
  (:method ((root root-ast) (func function-ast))
    (if (not (emptyp (function-name func)))
        (function-name func)
        (function-expression-name root func))))

(defgeneric function-expression-name (root func)
  (:documentation "Return the variable name assigned to the
function expression FUNC, if possible.")
  (:method ((root root-ast) (func function-ast))
    (when-let* ((parent (get-parent-ast root func))
                (lhs (typecase parent
                       (ecma-variable-declarator (ecma-name parent))
                       (ecma-assignment-expression (ecma-left parent))))
                (_ (typep lhs 'identifier-ast)))
      (source-text lhs))))

(defgeneric fast-check-parameter-names (func)
  (:documentation "Return parameter names for FUNC to use in
fast-check tests.")
  (:method ((func function-ast))
    (mapcar #'fast-check-parameter-name (function-parameters func))))

(defgeneric fast-check-parameter-name (param)
  (:documentation "Return the parameter name for PARAM to use in
fast-check tests.")
  (:method ((id identifier-ast))
    (source-text id))
  (:method ((pattern ecma-assignment-pattern))
    (first-child-fast-check-parameter-name pattern))
  (:method ((pattern ecma-rest-pattern))
    (first-child-fast-check-parameter-name pattern))
  (:method ((param typescript-parameter))
    (first-child-fast-check-parameter-name param))
  (:method ((ast ast))
    ;; for pattern destructure/non-standard params,
    ;; use a gensym for the parameter name
    (symbol-name (gensym))))

(-> first-child-fast-check-parameter-name (ast)
    (values (or string null) &optional))
(defun first-child-fast-check-parameter-name (ast)
  "Helper function returning the fast-check parameter name for the
first child of AST."
  (fast-check-parameter-name (first-child ast)))

(defgeneric fast-check-parameter-types (software func uri)
  (:documentation "Return the parameter types of FUNC to be used for
creating fast-check arbitraries.")
  (:method ((software ecma) (func function-ast) (uri t))
    ;; First, attempt to get the types from the function AST.  If not
    ;; found, attempt to get the types from type-view annotations.
    (or (ast-parameter-types func)
        (type-view-parameter-types software func uri))))

(defgeneric type-view-parameter-types (software func uri)
  (:documentation "Return the parameter types of FUNC from the annotations
provided by the type-view muse for the given URI.")
  (:method ((software ecma) (func function-ast) (uri string))
    (labels ((annotations (uri)
               "Return the annotations on the given URI from the argot server."
               (when (and uri *server*) (get-annotations *server* uri)))
             (annotation-in-range-p (annotation range)
               "Return T if the given annotation is in RANGE."
               (nest (contains range)
                     (convert 'source-range)
                     (slot-value annotation '|range|)))
             (parameter-type-contribution-p (contribution)
               "Return T if CONTRIBUTION corresponds to a parameter type."
               (typep (slot-value contribution '|data|) 'TypeCandidate))
             (parse-type-contribution (contribution)
               "Parse the given type contribution into a typescript
                type-annotation AST."
               (nest (parse-typescript-type-annotation-ast)
                     (slot-value (slot-value contribution '|data|) '|typeName|)))
             (invalid-types-p (types)
               "Return T if any TYPE in TYPES is invalid."
               (or (not (= (length (function-parameters func))
                           (length types)))
                   (some #'null types))))

      ;; Iterate over the type annotations provided by the type-view muse
      ;; and parse those corresponding to parameters to FUNC.
      (iter (with range = (ast-source-range (genome software) func))
            (for a in (annotations uri))
            (when-let* ((contribution (first (slot-value a '|contributions|)))
                        (_1 (annotation-in-range-p a range))
                        (_2 (parameter-type-contribution-p contribution)))
              (collect (parse-type-contribution contribution) into types))
            (finally (unless (invalid-types-p types) (return types))))))
  (:method ((software ecma) (func function-ast) (uri null))
    nil))

(-> parse-typescript-type-annotation (string) typescript-type-annotation)
(defun parse-typescript-type-annotation-ast (contribution)
  "Parse a typescript type-annotation AST from the given TypeCandidate
contribution from the type-view muse."
  (nest (find-if (of-type 'typescript-type-annotation))
        (convert 'list)
        (convert 'typescript-ts-ast)
        (format nil "var foo: ~a;")
        (translate-jsdoc-to-typescript contribution)))

(-> translate-jsdoc-to-typescript (string)
    (values string &optional))
(defun translate-jsdoc-to-typescript (contribution)
  "Translate a JSDoc contribution to the corresponding valid typescript type."
  (cond ((string^= "!" contribution)
         (translate-jsdoc-to-typescript (drop-prefix "!" contribution)))
        ((string*= "Object.<" contribution)
         (nest (translate-jsdoc-to-typescript)
               (string-replace-all "Object.<" contribution "Record<")))
        ((scan "[A-Za-z0-9_]+\\.<" contribution)
         (values (regex-replace-all "([A-Za-z0-9_]+)\\.<" contribution "\\1<")))
        (t contribution)))

(defgeneric ast-parameter-types (func)
  (:documentation "Return the parameter types for FUNC derived from the AST.")
  (:method ((func function-ast))
    (let ((types (mapcar #'parameter-type (function-parameters func))))
      (unless (some #'null types) types))))

(defgeneric arbitrary (ast)
  (:documentation "Create a fast-check arbitrary specification
from the given type annotation AST.

fast-check arbitraries are responsible for the random, but determinstic,
generation of values for function call arguments.

The specification returned will be a list where the first element
is the name of the arbitrary type to be generated and the subsequent
elements are arguments (which may be specifications themselves).

For instance, the spec

```
`(\"tuple\" (\"double\" ,(alist-hash-table '((\"next\" . t))))
            (\"bigint\"))
```

corresponds to the fast-check arbitrary

```
__fc.tuple(__fc.double({next: True}), __fc.bigint)
```
")
  (:method ((annotation typescript-type-annotation))
    (arbitrary (first-child annotation)))
  (:method ((literal typescript-literal-type))
    (list "constant" (source-text literal)))
  (:method ((identifier typescript-type-identifier))
    (arbitrary-for-base-type identifier))
  (:method ((predefined-type typescript-predefined-type))
    (arbitrary-for-base-type predefined-type))
  (:method ((array-type typescript-array-type))
    (arbitrary-for-container-type array-type))
  (:method ((tuple-type typescript-tuple-type))
    (arbitrary-for-container-type tuple-type))
  (:method ((union-type typescript-union-type))
    (arbitrary-for-container-type union-type))
  (:method ((intersection-type typescript-intersection-type))
    (arbitrary-for-container-type intersection-type))
  (:method ((generic-type typescript-generic-type))
    (arbitrary-for-generic-type generic-type))
  (:method ((object-type typescript-object-type))
    (arbitrary-for-object-type object-type))
  (:method ((maybe-type typescript-flow-maybe-type))
    (arbitrary-for-maybe-type maybe-type))
  (:method ((_ t))
    nil))

(define-constant +double-arbitrary-args+
  (alist-hash-table '(("next" . t)) :test #'equal)
  :documentation "Arguments controlling the generation of double values."
  :test #'equalp)

(define-constant +string-arbitrary-args+
  (alist-hash-table '(("minLength" . 0) ("maxLength" . 1024)) :test #'equal)
  :documentation "Arguments controlling the generation of string values."
  :test #'equalp)

(define-constant +array-arbitrary-args+
  (alist-hash-table '(("minLength" . 0) ("maxLength" . 128)) :test #'equal)
  :documentation "Arguments controlling the generation of array values."
  :test #'equalp)

(-> arbitrary-for-base-type (typescript-ast) list)
(defun arbitrary-for-base-type (base-type)
  "Create a fast-check arbitrary specification from the given
typescript BASE-TYPE, if possible."
  (string-case (source-text base-type)
    ("boolean" (list "boolean"))
    ("number" (list "double" +double-arbitrary-args+))
    ("bigint" (list "bigInt"))
    ("string" (list "string" +string-arbitrary-args+))
    ("object" (list "object"))
    ("Object" (list "anything"))
    ("unknown" (list "anything"))
    ("any" (list "anything"))
    ("Date" (list "date"))))

(-> arbitrary-for-container-type (typescript-ast) list)
(defun arbitrary-for-container-type (container-type)
  "Create a fast-check arbitrary specification from the given
typescript CONTAINER-TYPE, if possible."
  (and-let* ((elem-arbitraries (mapcar #'arbitrary
                                       (direct-children container-type)))
             ((notany #'null elem-arbitraries)))
    (append (typecase container-type
              (typescript-array-type (list "array"))
              (typescript-tuple-type (list "tuple"))
              (typescript-union-type (list "oneof"))
              (typescript-intersection-type (list "oneof")))
            elem-arbitraries
            (typecase container-type
              (typescript-array-type (list +array-arbitrary-args+))))))

(-> arbitrary-for-generic-type (typescript-ast)
    (values list &optional))
(defun arbitrary-for-generic-type (generic-type)
  "Create a fast-check arbitrary specification from the given typescript
GENERIC-TYPE interface, if possible."
  (string-case (source-text (first-child generic-type))
    ("NonNullable" (arbitrary-for-non-nullable-type generic-type))
    (("Array" "ReadonlyArray") (arbitrary-for-generic-array-type generic-type))
    (("Map" "Record") (arbitrary-for-generic-map-or-record-type generic-type))))

(-> arbitrary-for-non-nullable-type (typescript-ast)
    (values list &optional))
(defun arbitrary-for-non-nullable-type (non-nullable-type)
  "Create a fast-check arbitrary specification from the given typescript
NON-NULLABLE-TYPE interface, if possible."
  (arbitrary (car (generic-arguments non-nullable-type))))

(-> arbitrary-for-generic-array-type (typescript-ast) list)
(defun arbitrary-for-generic-array-type (array-type)
  "Create a fast-check arbitrary specification from the given typescript
ARRAY-TYPE interface, if possible."
  (when-let ((elem-type (arbitrary (car (generic-arguments array-type)))))
    (list "array" elem-type +array-arbitrary-args+)))

(-> arbitrary-for-generic-map-or-record-type (typescript-ast) list)
(defun arbitrary-for-generic-map-or-record-type (map-or-record-type)
  "Create a fast-check arbitrary specification from the given typescript
MAP-OR-RECORD-TYPE generic interface, if possible."
  (labels ((is-dictionary-arbitrary-p (map-or-record-type)
             "Return T if MAP-OR-RECORD-TYPE should be generated using a
              fast-check dictionary arbitrary."
             (let ((key (first (generic-arguments map-or-record-type))))
               (and (not (typep key 'typescript-literal-type))
                    (notany {typep _ 'typescript-literal-type}
                            (direct-children key)))))
           (dictionary-args (map-or-record-type)
             "Return key/value args representing MAP-OR-RECORD-TYPE
              for use by the fast-check dictionary arbitrary."
             (and-let* ((arbitraries (nest (mapcar #'arbitrary)
                                           (generic-arguments map-or-record-type)))
                        ((notany #'null arbitraries)))
               arbitraries))
           (is-record-arbitrary-p (map-or-record-type)
             "Return T if MAP-OR-RECORD-TYPE should be generated using a
              fast-check record arbitrary."
             (not (is-dictionary-arbitrary-p map-or-record-type)))
           (record-keys (map-or-record-type)
             "Return the keys in MAP-OR-RECORD-TYPE for use by the fast-check
              record arbitrary."
             (nest (mapcar #'source-text)
                   (remove-if-not {typep _ 'typescript-literal-type})
                   (convert 'list)
                   (first)
                   (generic-arguments map-or-record-type)))
           (record-type (map-or-record-type)
             "Return the type of the values in MAP-OR-RECORD-TYPE for use by
              the fast-check record arbitrary."
             (second (generic-arguments map-or-record-type)))
           (record-args (map-or-record-type)
             "Return a hash-table of arguments representing MAP-OR-RECORD-TYPE
              for use by the fast-check record arbitrary."
             (when-let ((keys (record-keys map-or-record-type))
                        (type (arbitrary (record-type map-or-record-type))))
               (nest (alist-hash-table)
                     (mapcar (lambda (key) (cons key type)) keys)))))
    (cond ((is-dictionary-arbitrary-p map-or-record-type)
           (when-let ((args (dictionary-args map-or-record-type)))
             (cons "dictionary" args)))
          ((is-record-arbitrary-p map-or-record-type)
           (when-let ((args (record-args map-or-record-type)))
             (list "record" args))))))

(-> arbitrary-for-object-type (typescript-ast) list)
(defun arbitrary-for-object-type (object-type)
  "Create a fast-check arbitrary specification from the given typescript
OBJECT-TYPE, if possible."
  (labels ((is-dictionary-arbitrary-p (object-type)
             "Return T if OBJECT-TYPE should be generated using a fast-check
              dictionary arbitrary."
             (typep (first-child object-type) 'typescript-index-signature))
           (dictionary-kv-types (object-type)
             "Return the types of the keys and values in the OBJECT-TYPE
              dictionary."
             (cdr (children (first-child object-type))))
           (dictionary-args (object-type)
             "Return key/value args representing OBJECT-TYPE for use
              by the fast-check dictionary arbitrary."
             (and-let* ((arbitraries (mapcar #'arbitrary
                                             (dictionary-kv-types object-type)))
                        ((notany #'null arbitraries)))
               arbitraries))
           (is-record-arbitrary-p (object-type)
             "Return T if OBJECT-TYPE should be generated using a fast-check
              record arbitrary."
             (not (null (children object-type))))
           (record-args (object-type)
             "Return a hash-table of arguments representing OBJECT-TYPE for
              use by the fast-check record arbitrary."
             (and-let* ((properties (direct-children object-type))
                        (keys (mapcar [#'source-text #'first #'children]
                                      properties))
                        (arbitraries (mapcar [#'arbitrary #'second #'children]
                                             properties))
                        ((notany #'null arbitraries)))
               (alist-hash-table (mapcar #'cons keys arbitraries))))
           (is-empty-object (object-type)
             "Return T if OBJECT-TYPE has no keys."
             (null (children object-type))))
    (cond ((is-dictionary-arbitrary-p object-type)
           (when-let ((args (dictionary-args object-type)))
             (cons "dictionary" args)))
          ((is-record-arbitrary-p object-type)
           (when-let ((args (record-args object-type)))
             (list "record" args)))
          ((is-empty-object object-type)
           (list "object" (alist-hash-table '(("maxKeys" . 0))))))))

(-> arbitrary-for-maybe-type (typescript-ast) list)
(defun arbitrary-for-maybe-type (maybe-type)
  "Create a fast-check arbitrary specification from the given typescript
flow MAYBE-TYPE, if possible."
  (when-let ((elem-arbitrary (arbitrary (first-child maybe-type))))
    (list "oneof"
          elem-arbitrary
          (list "constant" "null")
          (list "constant" "undefined"))))

(defgeneric generic-arguments (ast)
  (:documentation "Return the type arguments to a generic type
specification AST.")
  (:method ((ast typescript-generic-type))
    (generic-arguments (last-child ast)))
  (:method ((ast typescript-type-arguments))
    (direct-children ast))
  (:method ((ast ast))
    nil))

(defgeneric create-example-cases (software fast-check-tests)
  (:documentation "Create TestCase contributions with examples of
failing inputs to functions in SOFTWARE generated by FAST-CHECK-TESTS.")
  (:method ((software ecma) (fast-check-tests list))
    (labels ((contains-function-name-p (line)
               "Return TRUE if LINE contains a fast-check function name."
               (string-prefix-p "Fast-check function:" line))
             (parse-function-name (line)
               "Parse a fast-check function name from a LINE."
               (trim-whitespace (drop-prefix "Fast-check function:" line)))
             (contains-counterexample-p (line)
               "Return TRUE if LINE contains a counterexample from fast-check."
               (string-prefix-p "Counterexample:" line))
             (parse-counterexample-args (args)
               "Parse function ARGS from a fast-check counterexample into a
                list where each element correspondings to a single argument."
               (nest (mapcar #'source-text)
                     (direct-children)
                     (ecma-arguments)
                     (find-if (of-type 'call-ast))
                     (convert 'list)
                     (convert (ast-type software))
                     (format nil "foo(~a)" args)))
             (parse-counterexample (line)
               "Parse a counter example from fast-check specified in LINE."
               (nest (parse-counterexample-args)
                     (drop-suffix "]")
                     (drop-prefix "[")
                     (trim-whitespace)
                     (drop-prefix "Counterexample:" line)))
             (compile-and-run
                 (software
                  &aux
                    (*cmd-env*
                     `(("NODE_PATH"
                        . ,(path-join (get-system-base) "node_modules/"))
                       ,@*cmd-env*))
                    (*cmd-path*
                     (cons (path-join (get-system-base) "node_modules/.bin")
                           *cmd-path*)))
               "Compile (if typescript) and run SOFTWARE using the
                javascript interpreter, returning stdout."
               ;; TODO Use cmd or find some other solution to avoid
               ;; side-effecting the environment and working
               ;; directory.
               (with-working-directory ((get-system-base))
                 (if (typep software 'javascript)
                     (with-temporary-file (:pathname js-file :type "js")
                       (to-file software js-file)
                       (cmd! +javascript-interpreter+ js-file))
                     (with-temporary-file (:pathname ts-file :type "ts")
                       ;; Not using an explicit temporary for the
                       ;; destination as that would require --outFile,
                       ;; which breaks when the input file is a module.
                       ;; (Because --outFile is really meant for
                       ;; concatenating multiple inputs.)
                       (let ((js-file
                              (make-pathname :type "js" :defaults ts-file)))
                         (to-file software ts-file)
                         (assure string
                           (if (cmd? +typescript-compiler+ ts-file)
                               ($cmd +javascript-interpreter+ js-file)
                               ""))))))))
      ;; Create and run fast-check tests, creating TestCase objects
      ;; with failing inputs found by the fast-check library.
      (iter (with tested = (create-tested-software software fast-check-tests))
            (with function-name = nil)
            (for line in (lines (compile-and-run tested)))
            (when (contains-function-name-p line)
              (setf function-name (parse-function-name line)))
            (when (contains-counterexample-p line)
              (collect (make 'TestCase
                             :path (list "")
                             :testCaseKind TestCaseKind.UnitTest
                             :target function-name
                             :arguments (parse-counterexample line))))))))

(defgeneric create-tested-software (software fast-check-tests)
  (:documentation "Create a copy of SOFTWARE with FAST-CHECK-TESTS
added to the genome.")
  (:method ((software ecma) (fast-check-tests list))
    (labels ((create-arbitrary (spec)
               "Create a fast-check arbitrary from the given SPEC.

                If SPEC is a:
                  boolean - passed thru as \"true\" or \"false\"
                  number - written to string
                  string - passed thru directly
                  hash-table - written to string as a typescript object
                  list - the first element is taken as the name
                         of the arbitrary and subsequent elements
                         are taken as arguments (which may be SPECs
                         themselves)

                For instance, the spec

                ```
                `(\"tuple\" (\"double\" ,(alist-hash-table '((\"next\" . t))))
                            (\"bigint\"))
                ```

                corresponds to the fast-check arbitrary
                ```
                __fc.tuple(__fc.double({next: True}), __fc.bigint)
                ```"
               (cond ((eq spec t) "true")
                     ((eq spec nil) "false")
                     ((numberp spec) (write-to-string spec))
                     ((stringp spec) spec)
                     ((hash-table-p spec)
                      (nest (format nil "{~{~{~a~^: ~}~^, ~}}")
                            (mapcar (lambda (pair)
                                      (list (car pair)
                                            (create-arbitrary (cdr pair)))))
                            (hash-table-alist spec)))
                     ((listp spec)
                      (format nil "__fc.~a(~{~a~^, ~})"
                              (car spec)
                              (mapcar #'create-arbitrary (cdr spec))))))
             (create-arbitraries (arbitraries)
               "Create fast-check arbitraries from the given list of
                ARBITRARIES specs."
               (mapcar #'create-arbitrary arbitraries))
             (create-fast-check-module-import ()
               "Create an import AST for the fast-check library."
               (nest (first-child)
                     (convert (ast-type software))
                     (format nil "var __fc = require('fast-check');~%")))
             (create-assert-module-import ()
               "Create an import AST for the assert library."
               (nest (first-child)
                     (convert (ast-type software))
                     (format nil "var __assert = require('assert');~%")))
             (format-fast-check-assert (fast-check-test)
               "Create a string for a fast-check library assert with the given
                target, arguments, and arbitraries in FAST-CHECK-TEST."
               (format nil
                       "try {~%~
                            __fc.assert(~%~
                                __fc.property(~{~a~^, ~}, (~{~a: any~^, ~}) => {~%~
                                    __assert.doesNotThrow(() => ~a(~{~a~^, ~}))~%~
                                }),~%~
                                {seed: 0}~%~
                                  );~%~
                        } catch (err) {~%~
                            console.log('Fast-check function: ~a');~%~
                            console.log(err);~%~
                        }"
                        (create-arbitraries (arbitraries fast-check-test))
                        (arguments fast-check-test)
                        (test-target fast-check-test)
                        (arguments fast-check-test)
                        (test-target fast-check-test)))
             (create-fast-check-assert (fast-check-test)
               "Create a fast-check library assert corresponding to the given
                FAST-CHECK-TEST object.  The assert will test the function
                given as the target of the FAST-CHECK-TEST.  If fast-check
                finds a failure example, the function name and failure will
                be logged to stdout."
               (nest (first-child)
                     (convert (ast-type software))
                     (format-fast-check-assert fast-check-test)))
             (create-fast-check-asserts (fast-check-tests)
               "Create fast-check assert ASTs for each test in FAST-CHECK-TESTS."
               (mapcar #'create-fast-check-assert fast-check-tests)))

      ;; Create a copy of the software with the fast-check-tests
      ;; added to the genome.
      (nest (copy software :genome)
            (copy (genome software) :children)
            (append (direct-children (genome software))
                    (list (create-fast-check-module-import)
                          (create-assert-module-import))
                    (create-fast-check-asserts fast-check-tests))))))

(-> ast-type (ecma) symbol)
(defun ast-type (software)
  "Return the base AST type associated with the given SOFTWARE object."
  (etypecase software
    (javascript 'javascript-ast)
    (typescript-ts 'typescript-ts-ast)
    (typescript-tsx 'typescript-tsx-ast)))

(-> first-child (ast)
    (values (or ast null) &optional))
(defun first-child (ast)
  "Return the first child of AST, if possible."
  (first (children ast)))

(-> last-child (ast)
    (values (or ast null) &optional))
(defun last-child (ast)
  "Return the last child of AST, if possible."
  (lastcar (children ast)))
